
local defcolor = chatinfo.CHAT_MSG_PRINT[1]

local armed = false

local primaryspeed
local secondaryspeed
local targetdist
local launchtime

local stack_timer = Timer()

local function stack_timer_cb()
	local traveltime = os.difftime(os.time(), launchtime)
	local traveldist = traveltime * primaryspeed
	local impacttime = (targetdist - traveldist) / primaryspeed 
	local secondarydist = impacttime * secondaryspeed
	local curtargetdist = GetTargetDistance() or 0

	local color = ""
	if math.abs(curtargetdist - secondarydist) < 100 then
		color = "\12700ff00"
	elseif math.abs(curtargetdist - secondarydist) < 200 then
		color = "\127ffff00"
	end

	if impacttime > 0 then
		print(defcolor.."Impact in "..math.floor(impacttime).."s secondary at "..color..math.floor(secondarydist).."m "..defcolor.."(player "..math.floor(curtargetdist).."m)")
	end

	if traveldist < targetdist then
		stack_timer:SetTimeout(1000)
	end
end

local stackorator = {}
function stackorator:OnEvent(ev, data)
	if not armed then
		return
	end
	if ev == "INVENTORY_UPDATE" and GetInventoryItemClassType(data) == CLASSTYPE_ADDON and GetTargetInfo() then
		if not primaryspeed then
			primaryspeed = tonumber(GetInventoryItemExtendedDesc(data):match(".*Velocity: (%d+)m/s.*"))
		end

		if not primaryspeed then
			print("can't determine weapon speed")
			armed = false
			return
		end

		targetdist = tonumber(GetTargetDistance())
		launchtime = os.time()

		stack_timer:SetTimeout(1000, stack_timer_cb)
		armed = false
	end
end

RegisterEvent(stackorator, "INVENTORY_UPDATE")

local function stackorate_cb(_, args)
	secondaryspeed = args and tonumber(args[1]) or 35
	primaryspeed = args and tonumber(args[2])

	if stack_timer:IsActive() then
		stack_timer:Kill()
		armed = false
	else
		armed = not armed
	end
	print("stackorate armed: "..tostring(armed).." secondary: "..secondaryspeed.." primary: "..(primaryspeed or "auto"))
end

RegisterUserCommand("stackorate", stackorate_cb)




local autostack_timer = Timer()
local state = "stop"

local SLOT = 1
local SHOOTCMD = "+shoot"..tostring(SLOT)
local STOPSHOOTCMD = "+shoot"..tostring(SLOT).." 0"

local launchtime = os.time()
local targetdist = 0
local weaponspeed = 35
local ammo = 0

local function get_weapon_id(slot)
	local ids = {GetActiveShipSelectedWeaponGroupIDs()}
	local id
	if slot == 1 then
		id = ids[2]
	elseif slot == 2 then
		id = ids[1]
	else
		id = ids[3]
	end
	local port = next(GetActiveShipWeaponGroup(id))
	return GetActiveShipItemIDAtPort(port)
end

local function get_ammo_count(slot)
	return GetAddonItemInfo(get_weapon_id(slot))
end

local function checkstate()
	if state == "start_brake" then
		Game.SetDesiredSpeed(0)
		gkinterface.GKProcessCommand("+Brakes")
		gkinterface.GKProcessCommand("+turbo 0")

		if math.floor(GetActiveShipSpeed()) == 0 then
			gkinterface.GKProcessCommand("+Brakes 0")
			state = "start_shoot"
		end
		tick:SetTimeout(100, checkstate)
	elseif state == "start_shoot" then
		local weapon = get_weapon_id(slot)
		weaponspeed = tonumber(GetInventoryItemExtendedDesc(weapon):match(".*Velocity: (%d+)m/s.*"))
		if not weaponspeed then
			print("can't determine weapon speed")
			state = "stop"
		end

		ammo = get_ammo_count(SLOT)
		if not ammo then
			print("not an ammo based weapon")
			state = "stop"			
			return
		end

		gkinterface.GKProcessCommand(SHOOTCMD)
		launchtime = os.time()
		targetdist = tonumber(GetTargetDistance())

		state = "waitforshoot"
		tick:SetTimeout(100, checkstate)
	elseif state == "brake" then
		Game.SetDesiredSpeed(0)
		gkinterface.GKProcessCommand("+turbo 0")
		if math.floor(GetActiveShipSpeed()) == 0 then
			state = "waitfordist"
		end
		tick:SetTimeout(100, checkstate)
	elseif state == "waitfordist" then
		local traveltime = os.difftime(os.time(), launchtime)
		local traveldist = traveltime * weaponspeed
		local curtargetdist = GetTargetDistance() or 0
		if (targetdist - traveldist) < curtargetdist then
			state = "shoot"
		end
		tick:SetTimeout(100, checkstate)
	elseif state == "shoot" then
		ammo = get_ammo_count(SLOT)

		gkinterface.GKProcessCommand(SHOOTCMD)
		state = "waitforshoot"
		tick:SetTimeout(100, checkstate)
	elseif state == "waitforshoot" then
		local tmpammo = get_ammo_count(SLOT)
		if tmpammo == 0 then
			state = "stop"
		elseif tmpammo < ammo then
			state = "stopshoot"
		end
		tick:SetTimeout(100, checkstate)
	elseif state == "stopshoot" then
		gkinterface.GKProcessCommand(STOPSHOOTCMD)
		state = "accel"
		tick:SetTimeout(100, checkstate)
	elseif state == "accel" then
		gkinterface.GKProcessCommand("+turbo")
		if GetActiveShipSpeed() > 100 then
			state = "brake"
		end
		tick:SetTimeout(100, checkstate)
	elseif state == "stop" then
		gkinterface.GKProcessCommand(STOPSHOOTCMD)		
		print("done!")
	else
		print("unknown state "..tostring(state))
		state = "stop"
	end
end

local function stop()
	tick:Kill()
	state = "stop"
	checkstate()
end
RegisterUserCommand("asstop", stop)

local function start()
	state = "start_brake"
	checkstate()
end
RegisterUserCommand("asstart", start)

local function start()
	state = "start_brake"
	checkstate()
end
RegisterUserCommand("asstart", start)

